#include <osgCal/Model>

#include <osgDB/Registry>
#include <osgDB/Input>
#include <osgDB/Output>

using namespace osg;
using namespace osgDB;
using namespace osgCal;

// forward declare functions to use later.
bool Model_readLocalData(Object& obj, Input& fr);
bool Model_writeLocalData(const Object& obj, Output& fw);

bool Model_matchModeStr(const char* str,int& mode);
const char* Model_getModeStr(int value);

RegisterDotOsgWrapperProxy g_ModelProxy
(
    new osgCal::Model,
    "Model",
    "Object Node Model",
    &Model_readLocalData,
    &Model_writeLocalData
);

bool Model_readLocalData(Object& obj, Input& fr)
{
    bool iteratorAdvanced = false;

    Model& model = static_cast<Model&>(obj);

    osg::ref_ptr<osgCal::CoreModel> proto = new osgCal::CoreModel();

    osgCal::CoreModel *core = static_cast<osgCal::CoreModel *>(fr.readObjectOfType(*proto));

    if (core) {
	core->loadAllTextures();
	model.create(core);
        iteratorAdvanced = true;
    }

    if (fr.matchSequence("starting")) {
        if (fr[1].isInt()) {
            int animation;
            fr[1].getInt(animation);
            model.loop(animation, 1.0f, 0.0f);
            iteratorAdvanced = true;
            fr += 2;
        }
    }

    return iteratorAdvanced;
}

bool Model_writeLocalData(const Object& obj, Output& fw)
{
    const Model& model = static_cast<const Model&>(obj);
    std::vector<std::string> items;

    fw.writeObject(*model.getCoreModel());

    return true;
}
